const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class BlocksDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const blocks = await db.blocks.create(
      {
        id: data.id || undefined,

        type: data.type || null,
        order_index: data.order_index || null,
        visible: data.visible || false,

        config: data.config || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await blocks.setProfile_page(data.profile_page || null, {
      transaction,
    });

    await blocks.setOrganizations(data.organizations || null, {
      transaction,
    });

    return blocks;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const blocksData = data.map((item, index) => ({
      id: item.id || undefined,

      type: item.type || null,
      order_index: item.order_index || null,
      visible: item.visible || false,

      config: item.config || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const blocks = await db.blocks.bulkCreate(blocksData, { transaction });

    // For each item created, replace relation files

    return blocks;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const blocks = await db.blocks.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.order_index !== undefined)
      updatePayload.order_index = data.order_index;

    if (data.visible !== undefined) updatePayload.visible = data.visible;

    if (data.config !== undefined) updatePayload.config = data.config;

    updatePayload.updatedById = currentUser.id;

    await blocks.update(updatePayload, { transaction });

    if (data.profile_page !== undefined) {
      await blocks.setProfile_page(
        data.profile_page,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await blocks.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return blocks;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const blocks = await db.blocks.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of blocks) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of blocks) {
        await record.destroy({ transaction });
      }
    });

    return blocks;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const blocks = await db.blocks.findByPk(id, options);

    await blocks.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await blocks.destroy({
      transaction,
    });

    return blocks;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const blocks = await db.blocks.findOne({ where }, { transaction });

    if (!blocks) {
      return blocks;
    }

    const output = blocks.get({ plain: true });

    output.button_links_block = await blocks.getButton_links_block({
      transaction,
    });

    output.social_links_block = await blocks.getSocial_links_block({
      transaction,
    });

    output.profile_page = await blocks.getProfile_page({
      transaction,
    });

    output.organizations = await blocks.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.profile_pages,
        as: 'profile_page',

        where: filter.profile_page
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.profile_page
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  title: {
                    [Op.or]: filter.profile_page
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.config) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('blocks', 'config', filter.config),
        };
      }

      if (filter.order_indexRange) {
        const [start, end] = filter.order_indexRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            order_index: {
              ...where.order_index,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            order_index: {
              ...where.order_index,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.visible) {
        where = {
          ...where,
          visible: filter.visible,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.blocks.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('blocks', 'type', query),
        ],
      };
    }

    const records = await db.blocks.findAll({
      attributes: ['id', 'type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.type,
    }));
  }
};
